#ifndef LINKEDHASHMAP_H
#define LINKEDHASHMAP_H

template <class K, class V>
class LinkedHashEntry {

public:
	K key;
	V value;
	LinkedHashEntry<K, V> *next;

	LinkedHashEntry(K newKey, V newValue) {
		key = newKey;
		value = newValue;
		next = NULL;
	}

};


template <class K, class V>
class HashMap {

private:
	LinkedHashEntry<K, V> **table;
	int tableSize;
	int numItems;
	int (*hashFunc)(const K &);

public:

	HashMap(int size, int (*hashFn)(const K &));
	~HashMap();

	bool contains(K key);
	V get(K key); 
	void put(K key, V value);
	void remove(K key);
	int size() const;
	int getHashTableSize() const;
	void clear();
	void display();
	double loadFactor() const;
};

#endif